/**************************************************************************\
|
|    Copyright (C) 2012 Centrum Wiskunde & Informatica, The Netherlands
|
|    Contact:
|    Marc Stevens
|    Cryptology Group
|    Centrum Wiskunde & Informatica
|    P.O. Box 94079, 1090 GB Amsterdam, Netherlands
|    marc@marc-stevens.nl
|
|  Permission is hereby granted, free of charge, to any person obtaining a copy
|  of this software and associated documentation files (the "Software"), to deal
|  in the Software without restriction, including without limitation the rights
|  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
|  copies of the Software, and to permit persons to whom the Software is
|  furnished to do so, subject to the following conditions:
|
|  The above copyright notice and this permission notice shall be included in
|  all copies or substantial portions of the Software.
|
|  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
|  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
|  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
|  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
|  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
|  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
|  THE SOFTWARE.
|
|  Contributions were made by: Dan Shumow (Microsoft Research)
|
\**************************************************************************/

// this file was generated by the 'parse_bitrel' program in the tools section
// using the data files from directory 'tools/data/3565'
//
// see also ubc_check.h and ubc_check.c
//
// ubc_check in ubc_check.c is programmatically generated and the unavoidable bitconditions have been hardcoded
// this is a directly verifiable version named ubc_check_verify
// ubc_check has been verified against ubc_check_verify using the 'ubc_check_test' program in the tools section

#include <stdint.h>
#include "ubc_check.h"

void ubc_check_verify(const uint32_t W[80], uint32_t dvmask[DVMASKSIZE])
{
	for (unsigned i=0; i < DVMASKSIZE; ++i)
		dvmask[i]=0xFFFFFFFF;

	if (	   (0^((W[37]>>4)&1)^((W[39]>>4)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[41]>>4)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[42]>>29)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[43]>>4)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[46]>>29)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[47]>>29)&1))!=1
		|| (0^((W[61]>>1)&1)^((W[62]>>6)&1))!=1
		|| (0^((W[59]>>5)&1)^((W[63]>>30)&1))!=0
		|| (0^((W[58]>>0)&1)^((W[63]>>30)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<0));

	if (	   (0^((W[38]>>4)&1)^((W[40]>>4)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[42]>>4)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[43]>>29)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[44]>>4)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[47]>>29)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[48]>>29)&1))!=1
		|| (0^((W[62]>>1)&1)^((W[63]>>6)&1))!=1
		|| (0^((W[60]>>5)&1)^((W[64]>>30)&1))!=0
		|| (0^((W[59]>>0)&1)^((W[64]>>30)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<1));

	if (	   (0^((W[35]>>4)&1)^((W[39]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[41]>>4)&1))!=1
		|| (0^((W[39]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[43]>>4)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[44]>>29)&1))!=1
		|| (0^((W[39]>>4)&1)^((W[45]>>4)&1))!=1
		|| (0^((W[39]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[48]>>29)&1))!=1
		|| (0^((W[39]>>4)&1)^((W[49]>>29)&1))!=1
		|| (0^((W[63]>>1)&1)^((W[64]>>6)&1))!=1
		|| (0^((W[60]>>0)&1)^((W[61]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<2));

	if (	   (0^((W[36]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[42]>>4)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[44]>>4)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[45]>>29)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[46]>>4)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[49]>>29)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[50]>>29)&1))!=1
		|| (0^((W[61]>>0)&1)^((W[62]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<3));

	if (	   (0^((W[35]>>1)&1)^((W[36]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[40]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[42]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[44]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[46]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[47]>>1)&1))!=1
		|| (0^((W[61]>>2)&1)^((W[62]>>7)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<4));

	if (	   (0^((W[37]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[43]>>4)&1))!=1
		|| (0^((W[41]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[45]>>4)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[46]>>29)&1))!=1
		|| (0^((W[41]>>4)&1)^((W[47]>>4)&1))!=1
		|| (0^((W[41]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[50]>>29)&1))!=1
		|| (0^((W[41]>>4)&1)^((W[51]>>29)&1))!=1
		|| (0^((W[62]>>0)&1)^((W[63]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<5));

	if (	   (0^((W[36]>>1)&1)^((W[37]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[41]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[43]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[45]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[47]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[48]>>1)&1))!=1
		|| (0^((W[62]>>2)&1)^((W[63]>>7)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<6));

	if (	   (0^((W[35]>>4)&1)^((W[39]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[44]>>4)&1))!=1
		|| (0^((W[42]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[46]>>4)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[47]>>29)&1))!=1
		|| (0^((W[42]>>4)&1)^((W[48]>>4)&1))!=1
		|| (0^((W[42]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[51]>>29)&1))!=1
		|| (0^((W[42]>>4)&1)^((W[52]>>29)&1))!=1
		|| (0^((W[63]>>0)&1)^((W[64]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<7));

	if (	   (0^((W[37]>>1)&1)^((W[38]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[42]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[44]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[46]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[48]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[49]>>1)&1))!=1
		|| (0^((W[63]>>2)&1)^((W[64]>>7)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<8));

	if (	   (0^((W[36]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[45]>>4)&1))!=1
		|| (0^((W[43]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[47]>>4)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[48]>>29)&1))!=1
		|| (0^((W[43]>>4)&1)^((W[49]>>4)&1))!=1
		|| (0^((W[43]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[52]>>29)&1))!=1
		|| (0^((W[43]>>4)&1)^((W[53]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<9));

	if (	   (0^((W[35]>>1)&1)^((W[36]>>6)&1))!=1
		|| (0^((W[38]>>1)&1)^((W[39]>>6)&1))!=1
		|| (0^((W[38]>>1)&1)^((W[40]>>1)&1))!=1
		|| (0^((W[42]>>1)&1)^((W[43]>>6)&1))!=1
		|| (0^((W[42]>>1)&1)^((W[45]>>6)&1))!=1
		|| (0^((W[42]>>1)&1)^((W[47]>>6)&1))!=1
		|| (0^((W[42]>>1)&1)^((W[49]>>6)&1))!=1
		|| (0^((W[42]>>1)&1)^((W[50]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<10));

	if (	   (0^((W[36]>>4)&1)^((W[37]>>4)&1))!=1
		|| (0^((W[36]>>4)&1)^((W[41]>>29)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[46]>>4)&1))!=1
		|| (0^((W[44]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[48]>>4)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[49]>>29)&1))!=1
		|| (0^((W[44]>>4)&1)^((W[50]>>4)&1))!=1
		|| (0^((W[44]>>4)&1)^((W[51]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[53]>>29)&1))!=1
		|| (0^((W[44]>>4)&1)^((W[54]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<11));

	if (	   (0^((W[36]>>1)&1)^((W[37]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[40]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[41]>>1)&1))!=1
		|| (0^((W[43]>>1)&1)^((W[44]>>6)&1))!=1
		|| (0^((W[43]>>1)&1)^((W[46]>>6)&1))!=1
		|| (0^((W[43]>>1)&1)^((W[48]>>6)&1))!=1
		|| (0^((W[43]>>1)&1)^((W[50]>>6)&1))!=1
		|| (0^((W[43]>>1)&1)^((W[51]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<12));

	if (	   (0^((W[37]>>4)&1)^((W[38]>>4)&1))!=1
		|| (0^((W[35]>>3)&1)^((W[39]>>28)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[42]>>29)&1))!=1
		|| (0^((W[41]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[47]>>4)&1))!=1
		|| (0^((W[45]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[49]>>4)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[50]>>29)&1))!=1
		|| (0^((W[45]>>4)&1)^((W[51]>>4)&1))!=1
		|| (0^((W[45]>>4)&1)^((W[52]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[54]>>29)&1))!=1
		|| (0^((W[45]>>4)&1)^((W[55]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<13));

	if (	   (0^((W[37]>>1)&1)^((W[37]>>6)&1))!=0
		|| (0^((W[37]>>1)&1)^((W[38]>>6)&1))!=1
		|| (0^((W[35]>>5)&1)^((W[39]>>30)&1))!=0
		|| (0^((W[40]>>1)&1)^((W[41]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[42]>>1)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[45]>>6)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[47]>>6)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[49]>>6)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[51]>>6)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[52]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<14));

	if (	   (0^((W[38]>>4)&1)^((W[39]>>4)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[43]>>29)&1))!=1
		|| (0^((W[42]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[48]>>4)&1))!=1
		|| (0^((W[46]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[50]>>4)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[51]>>29)&1))!=1
		|| (0^((W[46]>>4)&1)^((W[52]>>4)&1))!=1
		|| (0^((W[46]>>4)&1)^((W[53]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[55]>>29)&1))!=1
		|| (0^((W[46]>>4)&1)^((W[56]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<15));

	if (	   (0^((W[36]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[52]>>29)&1)^((W[53]>>29)&1))!=0
		|| (0^((W[50]>>29)&1)^((W[53]>>29)&1))!=1
		|| (0^((W[49]>>4)&1)^((W[53]>>29)&1))!=0
		|| (0^((W[49]>>29)&1)^((W[53]>>29)&1))!=1
		|| (0^((W[47]>>4)&1)^((W[53]>>29)&1))!=1
		|| (0^((W[63]>>1)&1)^((W[64]>>6)&1))!=1
		|| (0^((W[60]>>0)&1)^((W[61]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<16));

	if (	   (0^((W[37]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[53]>>29)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[51]>>29)&1)^((W[54]>>29)&1))!=1
		|| (0^((W[50]>>4)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[50]>>29)&1)^((W[54]>>29)&1))!=1
		|| (0^((W[48]>>4)&1)^((W[54]>>29)&1))!=1
		|| (0^((W[61]>>0)&1)^((W[62]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<17));

	if (	   (0^((W[36]>>1)&1)^((W[37]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[42]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[43]>>1)&1))!=1
		|| (0^((W[50]>>6)&1)^((W[51]>>1)&1))!=0
		|| (0^((W[48]>>6)&1)^((W[51]>>1)&1))!=0
		|| (0^((W[47]>>1)&1)^((W[51]>>1)&1))!=1
		|| (0^((W[61]>>2)&1)^((W[62]>>7)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<18));

	if (	   (0^((W[35]>>3)&1)^((W[39]>>28)&1))!=0
		|| (0^((W[35]>>4)&1)^((W[39]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[54]>>29)&1)^((W[55]>>29)&1))!=0
		|| (0^((W[52]>>29)&1)^((W[55]>>29)&1))!=1
		|| (0^((W[51]>>4)&1)^((W[55]>>29)&1))!=0
		|| (0^((W[51]>>29)&1)^((W[55]>>29)&1))!=1
		|| (0^((W[49]>>4)&1)^((W[55]>>29)&1))!=1
		|| (0^((W[62]>>0)&1)^((W[63]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<19));

	if (	   (0^((W[35]>>30)&1)^((W[36]>>3)&1))!=1
		|| (0^((W[35]>>30)&1)^((W[40]>>28)&1))!=1
		|| (0^((W[36]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[39]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[55]>>29)&1)^((W[56]>>29)&1))!=0
		|| (0^((W[53]>>29)&1)^((W[56]>>29)&1))!=1
		|| (0^((W[52]>>4)&1)^((W[56]>>29)&1))!=0
		|| (0^((W[52]>>29)&1)^((W[56]>>29)&1))!=1
		|| (0^((W[50]>>4)&1)^((W[56]>>29)&1))!=1
		|| (0^((W[63]>>0)&1)^((W[64]>>5)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<20));

	if (	   (0^((W[36]>>30)&1)^((W[37]>>3)&1))!=1
		|| (0^((W[36]>>30)&1)^((W[41]>>28)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[56]>>29)&1)^((W[57]>>29)&1))!=0
		|| (0^((W[54]>>29)&1)^((W[57]>>29)&1))!=1
		|| (0^((W[53]>>4)&1)^((W[57]>>29)&1))!=0
		|| (0^((W[53]>>29)&1)^((W[57]>>29)&1))!=1
		|| (0^((W[51]>>4)&1)^((W[57]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<21));

	if (	   (0^((W[36]>>0)&1)^((W[37]>>5)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[40]>>6)&1))!=1
		|| (0^((W[39]>>1)&1)^((W[41]>>1)&1))!=1
		|| (0^((W[36]>>0)&1)^((W[41]>>30)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[45]>>6)&1))!=1
		|| (0^((W[44]>>1)&1)^((W[46]>>1)&1))!=1
		|| (0^((W[53]>>6)&1)^((W[54]>>1)&1))!=0
		|| (0^((W[51]>>6)&1)^((W[54]>>1)&1))!=0
		|| (0^((W[50]>>1)&1)^((W[54]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<22));

	if (	   (0^((W[37]>>30)&1)^((W[38]>>3)&1))!=1
		|| (0^((W[37]>>30)&1)^((W[42]>>28)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[42]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[57]>>29)&1)^((W[58]>>29)&1))!=0
		|| (0^((W[55]>>29)&1)^((W[58]>>29)&1))!=1
		|| (0^((W[54]>>4)&1)^((W[58]>>29)&1))!=0
		|| (0^((W[54]>>29)&1)^((W[58]>>29)&1))!=1
		|| (0^((W[52]>>4)&1)^((W[58]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<23));

	if (	   (0^((W[37]>>0)&1)^((W[38]>>5)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[41]>>6)&1))!=1
		|| (0^((W[40]>>1)&1)^((W[42]>>1)&1))!=1
		|| (0^((W[37]>>0)&1)^((W[42]>>30)&1))!=1
		|| (0^((W[45]>>1)&1)^((W[46]>>6)&1))!=1
		|| (0^((W[45]>>1)&1)^((W[47]>>1)&1))!=1
		|| (0^((W[54]>>6)&1)^((W[55]>>1)&1))!=0
		|| (0^((W[52]>>6)&1)^((W[55]>>1)&1))!=0
		|| (0^((W[51]>>1)&1)^((W[55]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<24));

	if (	   (0^((W[38]>>30)&1)^((W[39]>>3)&1))!=1
		|| (0^((W[38]>>30)&1)^((W[43]>>28)&1))!=1
		|| (0^((W[39]>>4)&1)^((W[43]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[51]>>29)&1))!=0
		|| (0^((W[58]>>29)&1)^((W[59]>>29)&1))!=0
		|| (0^((W[56]>>29)&1)^((W[59]>>29)&1))!=1
		|| (0^((W[55]>>4)&1)^((W[59]>>29)&1))!=0
		|| (0^((W[55]>>29)&1)^((W[59]>>29)&1))!=1
		|| (0^((W[53]>>4)&1)^((W[59]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<25));

	if (	   (0^((W[38]>>0)&1)^((W[39]>>5)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[42]>>6)&1))!=1
		|| (0^((W[41]>>1)&1)^((W[43]>>1)&1))!=1
		|| (0^((W[38]>>0)&1)^((W[43]>>30)&1))!=1
		|| (0^((W[46]>>1)&1)^((W[47]>>6)&1))!=1
		|| (0^((W[46]>>1)&1)^((W[48]>>1)&1))!=1
		|| (0^((W[55]>>6)&1)^((W[56]>>1)&1))!=0
		|| (0^((W[53]>>6)&1)^((W[56]>>1)&1))!=0
		|| (0^((W[52]>>1)&1)^((W[56]>>1)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<26));

	if (	   (0^((W[36]>>4)&1)^((W[38]>>4)&1))!=1
		|| (0^((W[39]>>30)&1)^((W[40]>>3)&1))!=1
		|| (0^((W[39]>>30)&1)^((W[44]>>28)&1))!=1
		|| (0^((W[40]>>4)&1)^((W[44]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[48]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[48]>>4)&1)^((W[51]>>29)&1))!=0
		|| (0^((W[48]>>4)&1)^((W[52]>>29)&1))!=0
		|| (0^((W[59]>>29)&1)^((W[60]>>29)&1))!=0
		|| (0^((W[57]>>29)&1)^((W[60]>>29)&1))!=1
		|| (0^((W[56]>>4)&1)^((W[60]>>29)&1))!=0
		|| (0^((W[56]>>29)&1)^((W[60]>>29)&1))!=1
		|| (0^((W[54]>>4)&1)^((W[60]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<27));

	if (	   (0^((W[37]>>4)&1)^((W[39]>>4)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[41]>>3)&1)^((W[45]>>28)&1))!=0
		|| (0^((W[41]>>4)&1)^((W[45]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[49]>>4)&1)^((W[51]>>29)&1))!=0
		|| (0^((W[49]>>4)&1)^((W[52]>>29)&1))!=0
		|| (0^((W[49]>>4)&1)^((W[53]>>29)&1))!=0
		|| (0^((W[58]>>29)&1)^((W[61]>>29)&1))!=1
		|| (0^((W[57]>>4)&1)^((W[61]>>29)&1))!=0
		|| (0^((W[57]>>29)&1)^((W[61]>>29)&1))!=1
		|| (0^((W[55]>>4)&1)^((W[61]>>29)&1))!=1
		)
			dvmask[0] &= ~((uint32_t)(1<<28));

	if (	   (0^((W[53]>>29)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[52]>>29)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[50]>>4)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[48]>>29)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[47]>>29)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[45]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[42]>>3)&1)^((W[46]>>28)&1))!=0
		|| (0^((W[42]>>4)&1)^((W[46]>>29)&1))!=0
		|| (0^((W[40]>>4)&1)^((W[41]>>29)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[36]>>4)&1)^((W[41]>>29)&1))!=1
		|| (0^((W[58]>>4)&1)^((W[62]>>29)&1))!=0
		|| (0^((W[58]>>29)&1)^((W[59]>>29)&1))!=0
		|| (0^((W[56]>>4)&1)^((W[59]>>29)&1))!=0
		)
			dvmask[0] &= ~((uint32_t)(1<<29));

	if (	   (0^((W[37]>>4)&1)^((W[39]>>4)&1))!=1
		|| (0^((W[37]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[41]>>4)&1))!=0
		|| (0^((W[37]>>4)&1)^((W[42]>>29)&1))!=1
		|| (0^((W[43]>>3)&1)^((W[47]>>28)&1))!=0
		|| (0^((W[43]>>4)&1)^((W[47]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[46]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[51]>>4)&1)^((W[53]>>29)&1))!=0
		|| (0^((W[51]>>4)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[51]>>4)&1)^((W[55]>>29)&1))!=0
		|| (0^((W[59]>>4)&1)^((W[63]>>29)&1))!=0
		|| (0^((W[57]>>4)&1)^((W[59]>>29)&1))!=0
		)
			dvmask[0] &= ~((uint32_t)(1<<30));

	if (	   (0^((W[38]>>4)&1)^((W[40]>>4)&1))!=1
		|| (0^((W[38]>>4)&1)^((W[40]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[41]>>29)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[42]>>4)&1))!=0
		|| (0^((W[38]>>4)&1)^((W[43]>>29)&1))!=1
		|| (0^((W[44]>>3)&1)^((W[48]>>28)&1))!=0
		|| (0^((W[44]>>4)&1)^((W[48]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[49]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[50]>>29)&1))!=0
		|| (0^((W[47]>>4)&1)^((W[51]>>29)&1))!=0
		|| (0^((W[52]>>4)&1)^((W[54]>>29)&1))!=0
		|| (0^((W[52]>>4)&1)^((W[55]>>29)&1))!=0
		|| (0^((W[52]>>4)&1)^((W[56]>>29)&1))!=0
		|| (0^((W[60]>>4)&1)^((W[64]>>29)&1))!=0
		)
			dvmask[0] &= ~((uint32_t)(1<<31));

}
